//********************************************************************
//*** Thread/LinuxRecursivePosixMutexSpecialization.hh
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: LinuxRecursivePosixMutexSpecialization.hh,v 1.7 2008/01/27 16:42:29 mws Exp $
//********************************************************************

#ifndef INCLUDED_LINUXRECURSIVEPOSIXMUTEXSPECIALIZATION_H
#define INCLUDED_LINUXRECURSIVEPOSIXMUTEXSPECIALIZATION_H

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#ifdef HAVE_PTHREAD_MUTEXATTR_SETTYPE
#ifdef HAVE_PTHREAD_MUTEX_RECURSIVE_NP

#ifndef INCLUDED_ERRNO_H
#include "../Exceptions/Errno.hh"
#endif

#include <pthread.h>

namespace fatalmind {

class LinuxRecursivePosixMutexSpecialization {
	public:
		inline void recursive_ok() {
		}

	protected:
		LinuxRecursivePosixMutexSpecialization() {
			Errno::ThrowOnError(
				pthread_mutexattr_init(&d_mutexattr)
			);
			Errno::ThrowOnError(
				pthread_mutexattr_settype(&d_mutexattr
					, PTHREAD_MUTEX_RECURSIVE_NP
				)
			);
		}

		inline pthread_mutexattr_t* getAttr() {
			return &d_mutexattr;
		}

		~LinuxRecursivePosixMutexSpecialization() {
			pthread_mutexattr_destroy(&d_mutexattr);
		}
	protected:
		 pthread_mutexattr_t d_mutexattr;
};

} // namespace fatalmind

#endif // HAVE_HAVE_PTHREAD_MUTEX_RECURSIVE_NP
#endif // HAVE_PTHREAD_MUTEXATTR_SETTYPE

#endif
